#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stddef.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <netinet/in.h>

/* MAILCMD should be a valid shell command for sending mail that
 * can use STDIN for input.				*/
#define MAILCMD "mail -s \"FIREWALL LOG DAEMON\" root"

/* LOGFILE should be a named pipe (FIFO) that syslog will push
 * kernel logs through.
 * Create the fifo using the command:
 * 	mkfifo /var/log/kernelpipe
 * 
 * Edit /etc/syslog.conf and include a line that will push logs
 * through the pipe. Add the following line:
 * 	kern.info		|/var/log/kernelpipe
 *
 * Restart syslogd and you are ready to go!		*/
#define LOGFILE "/var/log/kernelpipe"

/* BUFFERSIZE is the number if log entries to queue before sending
 * them by mail. Set this to whatever is reasonable for you.	*/
#define BUFFERSIZE 10


#define PIDFILE "/var/run/firedaemon.pid"
#define BUFFERFILE "/var/tmp/firedaemon.buffer"

#define VERSION 1.0
#define CATCH 1

struct pktlog
{
  char date[16];
  char msg[96];
  char iface[5];
  char srcip[16];
  char srcip_res[255];
  int srcpt;
  char dstip[16];
  int dstpt;
  char dstpt_res[16];
  char proto[16];
  int icmptype;
  int icmpcode;
  char icmp_res[128];
};

struct pktlog tokenize (char *line);	/* turn raw log data into struct pktlog */
int sig_catch (int catch);	/* try to close down gracefully */
void quit (int signum);		/* close it down properly */
int highlander (char *opt);	/* there can be only one */
int readbuf (void);		/* read in the buffer file */
int writebuf (void);		/* write buffer file */
int icmp_resolve (int icmptype, int icmpcode, char *icmpst);
/* resolve icmp types and codes */

int fmt_prn (FILE * out, struct pktlog *pkt);	/* format for output */
void usage (char *app);		/* usage and die */
