#include "dmn.h"
struct pktlog
tokenize (char *line)
{
  const char delimiter[] = " ";
  const char colon[] = ":";
  char *token;
  char *chain;
  char *src;
  char *dst;
  struct pktlog newpkt;
  struct protoent *newproto;
  struct servent *new_pt;
  struct hostent *new_hst;
  struct in_addr hst;
  int count = 0;
  int tmproto;
  token = strtok (line, delimiter);	/* get month */
  strcpy (newpkt.date, token);	/* add to struct */
  strcat (newpkt.date, "-");	/* add a space */
  token = strtok (NULL, delimiter);	/* get day */
  strcat (newpkt.date, token);
  strcat (newpkt.date, "/");
  token = strtok (NULL, delimiter);	/* get time */
  strcat (newpkt.date, token);
  token = strtok (NULL, delimiter);	/* ignore host */
  token = strtok (NULL, delimiter);	/* ignore kernel: */
  token = strtok (NULL, delimiter);	/* ignore Packet */
  token = strtok (NULL, delimiter);	/* ignore log: */
  chain = strtok (NULL, delimiter);	/* get chain where pkt logged */
  token = strtok (NULL, delimiter);	/* get DENY/REJECT */
  strcpy (newpkt.msg, token);	/* add to msg */
  strcat (newpkt.msg, " in ");
  strcat (newpkt.msg, chain);	/* add chain to msg */
  token = strtok (NULL, delimiter);	/* get interface */
  strcpy (newpkt.iface, token);
  token = strtok (NULL, delimiter);	/* this is PROTO=%d */
  sscanf (token + 6, "%d", &tmproto);
  newproto = getprotobynumber (tmproto);
  strcpy (newpkt.proto, newproto->p_name);
  while (newpkt.proto[count] != '\0')
    {
      newpkt.proto[count] = tolower (newpkt.proto[count]);
      count++;
    }
  if (strcmp (newpkt.proto, "icmp") == 0)
    tmproto = 1;		/* re-use tmproto to indicate icmp */
  else
    tmproto = 0;
  src = strtok (NULL, delimiter);	/* this is srcip:port/icmptype */
  dst = strtok (NULL, delimiter);	/* this is dstip:port/icmpcode */
  token = strtok (src, colon);	/* split up src */
  strcpy (newpkt.srcip, token);
  strcpy (newpkt.srcip_res, token);
  token = strtok (NULL, delimiter);	/* this is src port */
  if (tmproto == 1)
    {				/* if this is an icmp pkt */
      sscanf (token, "%d", &newpkt.icmptype);
      newpkt.srcpt = 0;
    }
  else
    {
      sscanf (token, "%d", &newpkt.srcpt);
    }
  token = strtok (dst, colon);	/* split up dst */
  strcpy (newpkt.dstip, token);
  token = strtok (NULL, delimiter);	/* this is dst port */
  if (tmproto == 1)
    {
      sscanf (token, "%d", &newpkt.icmpcode);
      newpkt.dstpt = 0;
    }
  else
    {
      strcpy (newpkt.dstpt_res, token);
      sscanf (token, "%d", &newpkt.dstpt);
    }
  if (strcmp (newpkt.proto, "icmp") == 0)
    {
      newpkt.srcpt = 0;
      newpkt.dstpt = 0;
      strcpy (newpkt.dstpt_res, "0");
      icmp_resolve (newpkt.icmptype, newpkt.icmpcode, newpkt.icmp_res);
    }
  if ((new_pt = getservbyport (htons (newpkt.dstpt), newpkt.proto)) != NULL)
    strcpy (newpkt.dstpt_res, new_pt->s_name);
  inet_aton (newpkt.srcip, &hst);
  if ((new_hst = gethostbyaddr ((char *) &hst, sizeof (hst), AF_INET)) !=
      NULL)
    strcpy (newpkt.srcip_res, new_hst->h_name);
  return newpkt;
}
